/********************************************************
 *
 *
 * DHCP/BOOTP-Client
 *
 *
 *
 * anhe, 13.03.2009
 *
 * License: GPL v3
 *
 ********************************************************/

#include "dhcpc.h"

#if USE_DHCP

/* DHCP-Discover Packet */
PROGMEM char DHCP_Discover[] = { 0x01, 0x01, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, // op (1), htype (1), hlen (1), hops (1), transaction id (4)
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // seconds (2), flags (2), client ip add (4)
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // self ip addr (4), server ip addr
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // relay agent ip addr (4), client MAC (16)
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // optional server name (64)
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // optional tftp file (128)
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x63, 0x82, 0x53, 0x63,                         // magic cookie
                                 0x35, 0x01, 0x01,                               // Message Type: DHCP Discover
                                 0x37, 0x04, 0x01, 0x03, 0x02, 0x2a, 0xff,       // Parameterlist, Len,  1=subnet mask
                                 '%','E','N','D' };                              //                      3=router
                                                                                 //                      2=time offset
                                                                                 //                     42=NTP Server

/* Init DHCP-Client
 *
 * register udp application */
void dhcpc_init (void)
{
        // register port for dhcp-offer
	add_udp_app (BOOTPC_PORT, (void(*)(unsigned char))dhcp_offer);

	return;
}

/* Send DHCP-Discover */
void dhcp_discover (void)
{
	unsigned int byte_count;

	unsigned long bcast_ip = 0xffffffff;

	PGM_P dhcp_data_pointer = DHCP_Discover;
	for (byte_count = 0;byte_count<(MTU_SIZE-(UDP_DATA_START));byte_count++)
	{
		unsigned char b;
		b = pgm_read_byte(dhcp_data_pointer++);
		// transaction id,
		// simply we use the MAC-Addr
		if (byte_count == 4) b = MYMAC2;
		if (byte_count == 5) b = MYMAC3;
		if (byte_count == 6) b = MYMAC4;
		if (byte_count == 7) b = MYMAC5;
		// setup MAC-Addr
		if (byte_count == 28) b = MYMAC1;
		if (byte_count == 29) b = MYMAC2;
		if (byte_count == 30) b = MYMAC3;
		if (byte_count == 31) b = MYMAC4;
		if (byte_count == 32) b = MYMAC5;
		if (byte_count == 33) b = MYMAC6;
                // DHCP Message Type
		if (byte_count == 242) b = 1;	// 1     DHCPDISCOVER
						// 2     DHCPOFFER
						// 3     DHCPREQUEST
						// 4     DHCPDECLINE
             					// 5     DHCPACK
             					// 6     DHCPNAK
            					// 7     DHCPRELEASE

		eth_buffer[UDP_DATA_START + byte_count] = b;
		if (strncasecmp_P("%END",dhcp_data_pointer,4)==0)
		{
			byte_count++;
			break;
		}
	}

	create_new_udp_packet(byte_count,BOOTPC_PORT,BOOTPS_PORT,bcast_ip);
	DHCP_DEBUG("** DHCP-Discover send! **\r\n");
	return;
}

/* Handle DHCP-Offer */
void dhcp_offer (unsigned char index)
{
	DHCP_DEBUG("** Receive DHCP Offer! **\r\n");

	struct DHCP_OFFER *dhcp;
	dhcp = (struct DHCP_OFFER *)&eth_buffer[UDP_DATA_START];
	extern unsigned char myip[4];

	myip[0] = dhcp->ip[0];
	myip[1] = dhcp->ip[1];
	myip[2] = dhcp->ip[2];
	myip[3] = dhcp->ip[3];
	DHCP_DEBUG("DHCP IP: %i.%i.%i.%i\r\n", dhcp->ip[0], dhcp->ip[1], dhcp->ip[2], dhcp->ip[3]);

	return;
}

#endif //USE_DHCPC
