/********************************************************
 *
 *
 * Dallas onewire support
 *
 *
 *
 * anhe, 10.11.2008
 *
 *
 ********************************************************/
#include "config.h"

#if USE_ONEWIRE

#ifndef _ONEWIRE_H_
#define _ONEWIRE_H_ 

#include <stdio.h>
#include "usart.h"

#define MATCH_ROM	0x55
#define SKIP_ROM	0xCC
#define	SEARCH_ROM	0xF0

#define CONVERT_T	0x44	// DS1820 commands
#define READ		0xBE
#define WRITE		0x4E
#define EE_WRITE	0x48
#define EE_RECALL	0xB8

#define	SEARCH_FIRST	0xFF	// start new search
#define	PRESENCE_ERR	0xFF
#define	DATA_ERR	0xFE
#define LAST_DEVICE	0x00	// last device found
//			0x01 ... 0x40: continue searching

#define bit unsigned char

// onewire struct
#define MAX_OW_DEVICES 4
struct ow_device
{
	char id[16];
	char value[8];
};

struct ow_bus
{
	unsigned int state;
	char         bus_info[20];
	struct       ow_device dev[MAX_OW_DEVICES];
};

struct ow_bus ow;

/* variables */
volatile unsigned long onewire1_timer;
volatile unsigned long onewire2_timer;

void start_meas(void);
void read_meas(void);
void command_ow(void);

#endif //USE_ONEWIRE

#endif //_ONEWIRE_H_


