package require Tk

# IP-Adresse des Host auf dem cube_viewer.tcl laeuft
set gvar(host) "localhost"  

# Port-Adresse auf der cube_viewer.tcl lauscht
set gvar(port) 12345      

set gvar(count) 512

# GUI
pack [labelframe .f1 -text "Input"] -fill x -padx 5
pack [labelframe .f3 -text "Pattern"] -fill x -padx 5
pack [labelframe .f2 -text "Send"] -fill x -padx 5
pack [labelframe .f4 -text "Receive"] -fill x -padx 5
pack [entry .f1.count -textvar gvar(count) -width 5] -side left
pack [button .f1.send -text "send..." -command {send}] -side left
pack [button .f1.exit -text "exit" -command {exit}] -side right
pack [text .f2.output -height 10] -anchor s
pack [text .f4.receive -height 2] -anchor s
for {set i 0} {$i<8} {incr i} {
	pack [checkbutton .f3.p$i -text $i -variable gvar(p$i)] -side left
}

# TCP/IP-Socket zum Server oeffnen
set gvar(sock) [socket $gvar(host) $gvar(port)]
fconfigure $gvar(sock) -buffering line
fileevent  $gvar(sock) readable [list receive $gvar(sock)]

#************************************************
proc bin2hex {bin} {
	set result ""
	set prepend [string repeat 0 [expr (4-[string length $bin]%4)%4]]
	foreach g [regexp -all -inline {[01]{4}} $prepend$bin] {
		foreach {b3 b2 b1 b0} [split $g ""] {
			append result [format %X [expr {$b3*8+$b2*4+$b1*2+$b0}]]
		}
	}
	return $result
}

#************************************************
proc up_down_count {v} {
	global gvar
	incr gvar(count) $v
	if {$gvar(count)<0} {set gvar(count) 0}
	if {$gvar(count)>512} {set gvar(count) 512}
}

#************************************************
proc send {} {
	global gvar
	set gvar(led) {}
	for {set i 0} {$i < $gvar(count)} {incr i} {
		set gvar(led) [linsert $gvar(led) end $gvar(p[expr $i % 8])]
	}   
	set gvar(led) [bin2hex [join $gvar(led) ""]]
	set gvar(output) "set_led $gvar(led)"
	.f2.output delete 1.0 10.0
	.f2.output insert 1.0 $gvar(output)
	puts $gvar(sock) $gvar(output)
	flush $gvar(sock)
}

#************************************************
proc receive {sock} {
	if {[eof $sock] || [catch {gets $sock line}]} {
		close $sock
	} else {
		if {$line != ""} {
			eval $line
		}
	}
	.f4.receive delete 1.0 2.0
	.f4.receive insert 1.0 $line

}

#************************************************
proc update_ok {} {
	# nur Dummy
}

#************************************************
proc set_xyz {x y z} {
	# nur Dummy
}
