#***********************************************************************
#
#                intro_maker.tcl
#                ===============
#                Uwe Berger; 2001
#
# Dieses Tcl-Script zeichnet LED-Abbilder von einem Client auf und 
# verpackt diese C-like, um sie z.B. spaeter in die AVR-Firmware 
# einbinden zu koennen. Das Script stellt dabei ein Server dar und 
# empfaengt die Sequenzen via Socket (siehe auch Cube-Simulator...).
#
# Have fun!
# ---------
#
#***********************************************************************

set picture 1

#***************
proc server_accept {chan addr port} {
	fileevent $chan readable "server_do $chan"
	fconfigure $chan -buffering line
	#puts "Verbindung: $chan $addr $port"
}

#***************
proc server_do {chan} {
	global safe
	set cmd [gets $chan]
    if {[catch {puts $chan [$safe eval $cmd]}]} {
		if {[catch {puts $chan "$cmd???"}]} {
			#puts "Client $chan nicht mehr erreichbar!"
			close $chan
		}
	}	
}
 
#***************
proc set_led {leds} {
	global picture
	set line "\t//-->$picture"
	for {set i 0} {$i<128} {incr i 2} {
		if {![expr $i%32]} {
			set line "$line\n\t"
		}
		set line "$line 0x[string range "$leds" $i [expr $i+1]],"
	}
	puts $line
	incr picture
	return "update_ok"
}

#***************
proc get_xyz {} {
	return "set_xyz 8 8 8"
}


#***************
#***************
set safe [interp create -safe]
$safe alias set_led set_led
$safe alias get_xyz get_xyz

socket -server server_accept 12345

vwait forever


