#*************************************************************************
# Ein Client fuer cube_viewer.tcl...
#
# Schaltet alle LEDs der Reihe nach an...
#
#


set gvar(host) "localhost"
set gvar(port) 12345

set gvar(led_count) 0

#*************************************************************************
# Routinen
#
#
#----- receice -----
#
# Wird aufgerufen, wenn etwas im Empfangspuffer drin ist...
#
proc receive {sock} {
	if {[eof $sock] || [catch {gets $sock line}]} {
		close $sock
	} else {
		if {$line != ""} {
			eval $line
		}
	}
}


#----- set_xyz -----
#   (Serverbefehl)
#
proc set_xyz {x y z} {
	global gvar
	
	set gvar(x) $x
	set gvar(y) $y
	set gvar(z) $z
	set gvar(led_count) [expr $gvar(x) * $gvar(y) * $gvar(z)]
	init_led
}


#----- update_ok -----
#   (Serverbefehl)
#
proc update_ok {} {
	global gvar
	#puts "Server ok: $gvar(ebene_neu)"
	after 100 [list led_test $gvar(ebene_neu)]

}


#----- init_led -----
#
proc init_led {} {
	global gvar
	
	set gvar(led) {}
	for {set i 0} {$i < $gvar(led_count)} {incr i} {set gvar(led) [linsert $gvar(led) end 0]}
	#puts $gvar(led)
}


#----- send_cmd -----
#
proc send_cmd {cmd} {
	global gvar
	puts $gvar(sock) $cmd                          
	flush $gvar(sock) 
}


#****************************************************************
# Hier ist kommt das Ablaufprogramm fuer die LEDs...
#
#
#----- led_test -----
#
proc led_test {ebene} {
	global gvar

	set ebene_neu $ebene
	if {$ebene < $gvar(x)} {
		init_led
		set k [expr $gvar(x) * $gvar(y)]
		for {set i [expr $ebene * $k]} {$i < [expr ($ebene + 1) * $k]} {incr i} {set gvar(led) [lreplace $gvar(led) $i $i 1]}
		
		set ebene_neu [incr ebene_neu]
	} else {
		init_led
		set ebene_neu 0
	}
	send_cmd [list set_led $gvar(led)]
	set gvar(ebene_neu) $ebene_neu
}




#****** hier geht es los! *******
#
#

# TCP/IP-Socket zum Server oeffnen
set gvar(sock) [socket $gvar(host) $gvar(port)]
fconfigure $gvar(sock) -buffering line
fileevent  $gvar(sock) readable [list receive $gvar(sock)]


# Dimmension des Cubes vom Server holen
send_cmd get_xyz 

# warten, bis Replay vom Server kam und Ergebnis verarbeitet wurde
vwait gvar(led_count)

# die eigentliche Ablaufsteuerung fuer die LEDs
led_test 0


vwait forever 
