#*************************************************************************
# Ein Client fuer cube_viewer.tcl...
#
# Punkte und Linien zeichnen....
#  -aber noch nicht korrekt (es kommen krumme Linien raus...)
#


set gvar(host) "localhost"
set gvar(port) 12345

set gvar(led_count) 0

#*************************************************************************
# Routinen
#
#
#----- receice -----
#
# Wird aufgerufen, wenn etwas im Empfangspuffer drin ist...
#
proc receive {sock} {
	if {[eof $sock] || [catch {gets $sock line}]} {
		close $sock
	} else {
		if {$line != ""} {
			eval $line
		}
	}
}


#----- set_xyz -----
#   (Serverbefehl)
#
proc set_xyz {x y z} {
	global gvar
	
	set gvar(x) $x
	set gvar(y) $y
	set gvar(z) $z
	set gvar(led_count) [expr $gvar(x) * $gvar(y) * $gvar(z)]
	init_led
}


#----- update_ok -----
#   (Serverbefehl)
#
proc update_ok {} {
	global gvar
#	after 100 [list led_test $gvar(ebene_neu)]

}


#----- init_led -----
#
proc init_led {} {
	global gvar
	set gvar(led) {}
	for {set i 0} {$i < $gvar(led_count)} {incr i} {set gvar(led) [linsert $gvar(led) end 0]}
}


#----- send_cmd -----
#
proc send_cmd {cmd} {
	global gvar
	puts $gvar(sock) $cmd                          
	flush $gvar(sock) 
}


#---- get_distance ----
#
proc get_distance {x1 y1 z1 x2 y2 z2} {
	global gvar
	set dist [expr sqrt([expr pow([expr $x2 - $x1], 2)\
                                + pow([expr $y2 - $y1], 2)\
			        + pow([expr $z2 - $z1], 2)])]
	return $dist
}

#---- insert_pzw ----
#
proc insert_pzw {x y z} {
	global gvar
	set d [get_distance $x $y $z $gvar(xe) $gvar(ye) $gvar(ze)]
        set gvar(pzw) [linsert $gvar(pzw) end [list $d $x $y $z]]
}


#---- draw_point ----
#
proc draw_point {x y z} {
	global gvar
	set i [expr $x + ($y * $gvar(x)) + ($z * $gvar(x) * $gvar(y))]
	set gvar(led) [lreplace $gvar(led) $i $i 1]
}

#---- draw_line ----
#
# Die Punkte auf der Linie zw. Anfangs- und Endpunkt werden heuristisch
# bestimmt:
# Es wird schrittweise vom Ausgangspunkt die Entfernung der
# angrenzenden Punkte zum Endpunkt ermittelt. Der Punkt mit der geringsten
# Entfernung ist der nchste zu zeichnente Zwischenpunkt. Ab diesen 
# ermittelten Zwischenpunkt geht das Spiel weiter, bis der Endpunkt erreicht
# ist...
#
proc draw_line {xa ya za xe ye ze} {
	global gvar
	
	# Anfangspunkt der Linie zeichen...
	draw_point $xa $ya $za

	# Anfangs- und Endpunkt sind gleich, dann ist hier Schluss
	if {($xa == $xe) && ($ya == $ye) && ($za == $ze)} {return}

	# Endpunkt der Linie merken, da er fuer die Berechnung
	# der Entfernung immer gebraucht wird...
	set gvar(xe) $xe
	set gvar(ye) $ye
	set gvar(ze) $ze
	
	# Anfangspunkt ist auch gleich der 1. Punkt von dem der naechste
	# berechnet wird...
	set xz $xa
	set yz $ya
	set zz $za
	
	set d 1
	#set l 0
	# Schleife bis Endpunkt der Linie erreicht ist....
	while {$d > 0} {
		set gvar(pzw) {}
		insert_pzw [expr $xz - 1] [expr $yz - 1] [expr $zz - 1]
	        insert_pzw [expr $xz - 1] $yz            [expr $zz - 1]
        	insert_pzw [expr $xz - 1] [expr $yz + 1] [expr $zz - 1]
	        insert_pzw [expr $xz - 1] [expr $yz - 1] $zz 
        	insert_pzw [expr $xz - 1] $yz            $zz 
	        insert_pzw [expr $xz - 1] [expr $yz + 1] $zz 
        	insert_pzw [expr $xz - 1] [expr $yz - 1] [expr $zz + 1]
	        insert_pzw [expr $xz - 1] $yz            [expr $zz + 1]
	       	insert_pzw [expr $xz - 1] [expr $yz + 1] [expr $zz + 1]
        	insert_pzw $xz            [expr $yz - 1] [expr $zz - 1]
	        insert_pzw $xz            $yz            [expr $zz - 1]
	        insert_pzw $xz            [expr $yz + 1] [expr $zz - 1]
		insert_pzw $xz            [expr $yz - 1] $zz 
	        insert_pzw $xz            [expr $yz + 1] $zz 
        	insert_pzw $xz            [expr $yz - 1] [expr $zz + 1]
	        insert_pzw $xz            $yz            [expr $zz + 1]
	        insert_pzw $xz            [expr $yz + 1] [expr $zz + 1]
	        insert_pzw [expr $xz + 1] [expr $yz - 1] [expr $zz - 1]
	        insert_pzw [expr $xz + 1] $yz            [expr $zz - 1]
	        insert_pzw [expr $xz + 1] [expr $yz + 1] [expr $zz - 1]
	        insert_pzw [expr $xz + 1] [expr $yz - 1] $zz 
	        insert_pzw [expr $xz + 1] $yz            $zz 
	        insert_pzw [expr $xz + 1] [expr $yz + 1] $zz 
	        insert_pzw [expr $xz + 1] [expr $yz - 1] [expr $zz + 1]
	        insert_pzw [expr $xz + 1] $yz            [expr $zz + 1]
	        insert_pzw [expr $xz + 1] [expr $yz + 1] [expr $zz + 1]
		# Punkte so sortieren, dass der mit der geringsten Entfernung oben steht...	
		set gvar(pzw) [lsort -index 0 -increasing -real $gvar(pzw)]
		#puts $gvar(pzw)
		#puts "----"
		foreach {d xz yz zz} [lindex $gvar(pzw) 0] {break}
		# ... und diesen zeichnen
		draw_point $xz $yz $zz
		#incr l
	}
}



#****************************************************************
# Hier ist kommt das Ablaufprogramm fuer die LEDs...
#
#
#----- led_test -----
#
proc led_test {ebene} {
	global gvar
	draw_line 1 0 0 7 7 7 

	send_cmd [list set_led $gvar(led)]
}




#****** hier geht es los! *******
#
#

# TCP/IP-Socket zum Server oeffnen
set gvar(sock) [socket $gvar(host) $gvar(port)]
fconfigure $gvar(sock) -buffering line
fileevent  $gvar(sock) readable [list receive $gvar(sock)]


# Dimmension des Cubes vom Server holen
send_cmd get_xyz 

# warten, bis Replay vom Server kam und Ergebnis verarbeitet wurde
vwait gvar(led_count)

# die eigentliche Ablaufsteuerung fuer die LEDs
led_test 0


vwait forever 
