#*************************************************************************
# Ein Client fuer cube_viewer.tcl...
#
# ein paar 3D-Funktionen zeichnen....
#

source client_lib.tcl


#****************************************************************
# Hier ist kommt das Ablaufprogramm fuer die LEDs...
# ---------------------------------------------------
#
#----- display_led -----
#

set gvar(f) -1
set gvar(update_refresh) 500

proc display_led {} {
	global gvar
	
	init_led
	
	incr gvar(f)
	if {$gvar(f) > 8} {set gvar(f) 0}
	
	 send_cmd [list print_message "Function: $gvar(f)"]
	
	for {set x 0} {$x < $gvar(x)} {incr x} {
		for {set y 0} {$y < $gvar(y)} {incr y} {
		
			set xz [expr $x - 3.5]
			set yz [expr $y - 3.5]
		
			if {$gvar(f) == 0} {
			#--- z = (x/2)^2-(y/2)^2
			 set z [expr round(pow(($xz/2), 2) - pow(($yz/2), 2))]
			 set zv 3
			}
			
			if {$gvar(f) == 1} {
			#--- z = (x/2)^2+(y/3)^3
			 set z [expr round(pow(($xz/2), 2) + pow(($yz/3), 3))]
			 set zv 3
			}			
		
			if {$gvar(f) == 2} {
			#--- z=cos(sqrt(x^2+y2))
			 set z [expr round(cos(sqrt(pow($xz, 2) + pow($yz, 2))))]
			 set zv 1
			}
			

			if {$gvar(f) == 3} {
			#--- z=sin(sqrt(x^2+y2))
			 set z [expr round(sin(sqrt(pow($xz, 2) + pow($yz, 2))))]
			 set zv 1
			}

			if {$gvar(f) == 4} {
			#--- z=1.5^(4-x^2)*sin(y)
			 set z [expr round(pow(1.5, (4-pow($xz,2))*sin($yz)))]
			 set zv 0
			}

			if {$gvar(f) == 5} {
			#--- z=1.5^(4-sqrt(x^2+y^2))
			 set z [expr round(pow(1.5,(4-sqrt(pow($xz,2)+pow($yz,2)))))]
			 set zv 0
			}
			
			if {$gvar(f) == 6} {
			#--- z=tanh(x)+tanh(y^2)
			 set z [expr round(tanh($xz)+tanh(pow($yz, 2)))]
			 set zv 1
			}

			if {$gvar(f) == 7} {
			#--- z=sin(cos(x)-sqrt(x^2+y^2))
			 set z [expr round(sin(cos($xz)-sqrt(pow($xz, 2)+pow($yz, 2))))]
			 set zv 1
			}

			if {$gvar(f) == 8} {
			#--- z=sin(cos(x)-sqrt(x^2+y^2))
			 set z [expr round(cos(pow(3, (sin($xz)*tan($xz*$yz)))))]
			 set zv 1
			}

			#puts "$x $y $z"
			
			draw_point [expr int($xz + 3.5)] [expr int($yz + 3.5)] [expr $z + $zv]
		}
	}
	
	
	send_led
}


#****************************************************************
# die eigentliche Ablaufsteuerung fuer die LEDs starten
#
display_led


vwait forever 
