#          cube_point.tcl
#          ==============
#         Uwe Berger; 2008
#
# die diversen einkommentierten Stellen sind dem geschuldet, dass
# das Koordinatensysten der Hardware etwas anders ist, als hier 
# in der Software
#

set workdir [ file dirname $argv0 ]
cd $workdir
set workdir [ pwd ]
source client_lib.tcl

set gvar(raster) 30
set gvar(big_cursor) 0
set gvar(draw) 0

proc init {} {
	global gvar

#	set gvar(cursor_x) 0
#	set gvar(cursor_y) 0

	set gvar(cursor_x) [expr $gvar(x) - $gvar(big_cursor) - 1]
	set gvar(cursor_y) [expr $gvar(y) - $gvar(big_cursor) - 1]

	set gvar(cursor_z) 0
	set gvar(old_cursor_x) 0
	set gvar(old_cursor_y) 0
	set gvar(old_cursor_z) 0
	set temp $gvar(draw)
	set gvar(draw) 0
	send_cursor
	set gvar(draw) $temp
}

proc z_plus {} {
	global gvar
	if {$gvar(cursor_z) < [expr $gvar(z) - 1 - $gvar(big_cursor)]} {set gvar(cursor_z) [incr gvar(cursor_z) 1]}
	send_cursor
}

proc z_minus {} {
	global gvar
	if {$gvar(cursor_z) > 0} {set gvar(cursor_z) [incr gvar(cursor_z) -1]}
	send_cursor
}

proc send_cursor {} {
	global gvar
	if {!$gvar(draw)} {	
		init_led
	}
	set gvar(key) ""
#	draw_point $gvar(cursor_x) $gvar(cursor_y) $gvar(cursor_z)
	draw_point $gvar(cursor_y) $gvar(cursor_x) $gvar(cursor_z)
	if {$gvar(big_cursor)} {
#		draw_point [expr $gvar(cursor_x) + 1] $gvar(cursor_y) $gvar(cursor_z)
#		draw_point $gvar(cursor_x) [expr $gvar(cursor_y) + 1] $gvar(cursor_z)
#		draw_point $gvar(cursor_x) $gvar(cursor_y) [expr $gvar(cursor_z) + 1]
#		draw_point [expr $gvar(cursor_x) + 1] [expr $gvar(cursor_y) + 1] $gvar(cursor_z)
#		draw_point [expr $gvar(cursor_x) + 1] $gvar(cursor_y) [expr $gvar(cursor_z) + 1]
#		draw_point [expr $gvar(cursor_x) + 1] [expr $gvar(cursor_y) + 1] [expr $gvar(cursor_z) + 1]
#		draw_point $gvar(cursor_x) [expr $gvar(cursor_y) + 1] [expr $gvar(cursor_z) + 1]

		draw_point [expr $gvar(cursor_y) + 1] $gvar(cursor_x) $gvar(cursor_z)
		draw_point $gvar(cursor_y) [expr $gvar(cursor_x) + 1] $gvar(cursor_z)
		draw_point $gvar(cursor_y) $gvar(cursor_x) [expr $gvar(cursor_z) + 1]
		draw_point [expr $gvar(cursor_y) + 1] [expr $gvar(cursor_x) + 1] $gvar(cursor_z)
		draw_point [expr $gvar(cursor_y) + 1] $gvar(cursor_x) [expr $gvar(cursor_z) + 1]
		draw_point [expr $gvar(cursor_y) + 1] [expr $gvar(cursor_x) + 1] [expr $gvar(cursor_z) + 1]
		draw_point $gvar(cursor_y) [expr $gvar(cursor_x) + 1] [expr $gvar(cursor_z) + 1]
	}
	send_led
}

proc xy_pad {x y} {
	global gvar
#	set temp_x [expr $x / $gvar(raster)]
	set temp_x [expr $gvar(y) - ($x / $gvar(raster)) - 1]
	set temp_y [expr $y / $gvar(raster)]
	if {[expr $gvar(x) - $gvar(big_cursor)] > $temp_x} {
		set gvar(cursor_x) $temp_x
	}
	if {[expr $gvar(y) - $gvar(big_cursor)] > $temp_y} {
		set gvar(cursor_y) $temp_y
	}
	if {$gvar(cursor_x) != $gvar(old_cursor_x) || $gvar(cursor_y) != $gvar(old_cursor_y)} {
		send_cursor
		set gvar(old_cursor_x) $gvar(cursor_x)
		set gvar(old_cursor_y) $gvar(cursor_y)
	}
}

proc mscroll {bindtag} {
	bind $bindtag <Button-5> [list z_plus]
	bind $bindtag <Button-4> [list z_minus]
}

proc keypressed {key} {
	global gvar
	if {$key == "F1"} {
		if {$gvar(big_cursor)} {
			set gvar(big_cursor) 0
		} else {
			set gvar(big_cursor) 1
		}
	}
	if {$key == "F2"} {
		if {$gvar(draw)} {
			set gvar(draw) 0
		} else {
			set gvar(draw) 1
		}
	}
	if {$key == "Escape"} {
		init
	}
}


##################### Layout #######################
wm title . "Cube-Pad" 

labelframe .f2 -text "Mousepad"
label .f2.x -textvariable gvar(cursor_x)
label .f2.y -textvariable gvar(cursor_y)
label .f2.z -textvariable gvar(cursor_z)
canvas .f2.pad -width [expr $gvar(raster) * $gvar(x)] -height [expr $gvar(raster) * $gvar(x)] -bg black -bd 0
pack .f2 -fill both
grid .f2.x   -row 1 -column 0
grid .f2.y   -row 1 -column 1
grid .f2.z   -row 1 -column 2
grid .f2.pad -row 0 -column 0 -columnspan 3

labelframe .f3 -text "Options"
checkbutton .f3.c -text "big point (F1)" -variable gvar(big_cursor) -command init
checkbutton .f3.d -text "draw (F2)" -variable gvar(draw) 
pack .f3 -fill both
pack .f3.c -side left
pack .f3.d -side left

labelframe .f4 -text "Actions"
button .f4.clear -text "Clear (ESC)" -command init
button .f4.exit -text "Exit" -command exit
pack .f4 -fill both
pack .f4.clear -side left
pack .f4.exit -side left

bind .f2.pad <Motion> {xy_pad %x %y}
bind . <KeyPress> {keypressed %K}
mscroll .f2.pad

####################################################################

init



