/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        09.11.2007
 Description:    Html Seiten

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/
#ifndef _WEBPAGE_H
	#define _WEBPAGE_H

#if USE_HTTPD

//****************************************************************************
//Dateien und Webseiten am ende dieser Seite in Tabelle eintragen !!!!!!!
//****************************************************************************


//----------------------------------------------------------------------------
//Dazustellende Webseite
PROGMEM char Page1[] = {
	"<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"
	"<html>\n"
	"<head>\n"
	"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\" />\n"
	"<title>"AVR_WEBSERVER_NAME"</title>\n"
	"<style type=\"text/css\">\n"
	"<!--\n"
	"body { background: white; margin: 1em; font-family: arial,helvetica,sans-serif; width: 80%; }\n"
	"h1 { font-size: 2.8em; border: 1px solid; border-width: 0.1em; border-color: #06276d; \n"
	"     background: #ffcc06; color: #06276d; padding: 0.5em; }\n"
	"h2 { font-size: 1.2em; border: 1px solid; border-width: 0 0 0.1em 0; background: #efefef;\n"
	"     color: #06276d; padding: 0.3em; }\n"
	"td { text-align:center; padding: 0.1em; border: 0px; }\n"
	".foot { font-size: 0.8em; margin: 3em 0 0 0; padding: 0.8em; border: 1px solid;\n"
	"        border-width: 1px 0 0 0; width: 40%; border-color: #06276d; }\n"
	".bar { border: 1px solid; padding: 2px; border-color: #06276d; width: 400px; }\n"
	".graph { background-color: #06276d; height: 0.8em; }\n"
	".box { border: 1px solid; padding: 2px; width: 0.8em; height: 0.8em; }\n"
	".on  { background-color: #00d100; width: 0.8em; height: 0.8em; }\n"
	".off { background-color: #eaeaea; width: 0.8em; height: 0.8em; }\n"
	"-->\n"
	"</style>\n"
	"</head>\n"

	"<body>\n"
	"<h1>"AVR_WEBSERVER_NAME"</h1>\n"
	"<p>\n"
	"Die Implementierung des IP-Stacks basiert auf U.Radigs Software zum <a href=\"http://www.ulrichradig.de\">AVR mini Webserver</a>.\n"
	"Die Software wurde fuer den <a href=\"http://bralug.de/wiki/3D-LED-Display\">LED-Cube</a> von Uwe Berger angepasst.\n"
	"</p>\n"
	"<h2>Server Status</h2>\n"
	"<p>\n"
	"<dl>\n"
	"<dt>Server Version: "AVR_WEBSERVER_NAME"/"AVR_WEBSERVER_VERSION"</dt>\n"
	"<dt>Server Built: built on "__DATE__" "__TIME__", gcc: "__VERSION__"</dt>\n"
	"<dt>Current Time: %DATETIME</dt>\n"
	"<dt>Uptime: %UPTIME sec</dt>\n"
	"<dt>Total accesses: %VA@09</dt>\n"
	"</dl>\n"
	"</p>\n"

	// LED-Cube
	#if LED_CUBE
	"<h2>LED-Cube</h2>\n"
	"<p>\n"
	"<dl>\n"
	"<dt>Dimension: "CUBE_DIMENSION_WEB"</dt>\n"
	"<dt>IP-Port: "CUBE_IP_PORT_WEB"</dt>\n"
	"<dt>Connections: %CUBE_CONN</dt>\n"
	"<dt>%LED@00 %LED@01 %LED@02 %LED@03 %LED@04 %LED@05 %LED@06 %LED@07</dt>\n"
	"<dt>%LED@08 %LED@09 %LED@10 %LED@11 %LED@12 %LED@13 %LED@14 %LED@15</dt>\n"
	"<dt>%LED@16 %LED@17 %LED@18 %LED@19 %LED@20 %LED@21 %LED@22 %LED@23</dt>\n"
	"<dt>%LED@24 %LED@25 %LED@26 %LED@27 %LED@28 %LED@29 %LED@30 %LED@31</dt>\n"
	"<dt>%LED@32 %LED@33 %LED@34 %LED@35 %LED@36 %LED@37 %LED@38 %LED@39</dt>\n"
	"<dt>%LED@40 %LED@41 %LED@42 %LED@43 %LED@44 %LED@45 %LED@46 %LED@47</dt>\n"
	"<dt>%LED@48 %LED@49 %LED@50 %LED@51 %LED@52 %LED@53 %LED@54 %LED@55</dt>\n"
	"<dt>%LED@56 %LED@57 %LED@58 %LED@59 %LED@60 %LED@61 %LED@62 %LED@63</dt>\n"
	"</dl>\n"
	"</p>\n"
	#endif

	// OneWire
	#if USE_ONEWIRE
	"<h2>OneWire Bus</h2>\n"
	"<table>\n"
	"<tr><th>OneWire ID</th><th>Temperatur [&deg;C]</th></tr>\n"
	"<tr><td>%OWID@0</td><td>%OWVAL@0</td></tr>\n"
	"<tr><td>%OWID@1</td><td>%OWVAL@1</td></tr>\n"
	"<tr><td>%OWID@2</td><td>%OWVAL@2</td></tr>\n"
	"<tr><td>%OWID@3</td><td>%OWVAL@3</td></tr>\n"
	"</table>\n"
	#endif

	// footer
	"<div class=\"foot\">\n"
	"Uwe Berger; 2010<br>\n"
	"</div>\n"
	"</body></html>\n"
	"%END"};	


//Nur Dateiname und Pointer eintragen	
WEBPAGE_ITEM WEBPAGE_TABLE[] = // Befehls-Tabelle
{
	{"index.html",Page1},
	{NULL,NULL} 
};

#endif

#endif //_WEBPAGE_H
